KAccelGen Namespace Reference

## Classes

class | Deref
class | Deref_Key

## Functions

bool | isLegalAccelerator (const QString &str, uint index)
template<class Iter , class Deref >
void | loadPredefined (Iter begin, Iter end, QMap< QChar, bool > &keys)
template<class Iter , class Iter_Deref >
void | generate (Iter begin, Iter end, QStringList &target)
template<class Iter >
void | generateFromKeys (Iter begin, Iter end, QStringList &target)
void | generate (const QStringList &source, QStringList &target)
template<class Key >
void | generateFromValues (const QMap< Key, QString > &source, QStringList &target)
template<class Data >
void | generateFromKeys (const QMap< QString, Data > &source, QStringList &target)

## Detailed Description

Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection.

NOTE: When this file speaks of "accelerators", we really mean accelerators as defined by the KDE User Interface Guidelines. We do NOT mean "shortcuts", which are what's handled by most other KDE libraries with "accel" in the name.

In the Qt library, the mechanism for adding a keyboard accelerator to a menu item is to insert an '&' before the letter. Since we usually don't want to disturb the original collection, the idiom in these functions is to populate a "target" QStringList parameter with the input collectin's QStrings, plus possibly some added '&' characters.

That is the mechanism. Here is the policy, in order of decreasing importance (it may seem like these are implementation details, but IMHO the policy is an important part of the interface):

1. If the string already contains an '&' character, skip this string, because we consider such strings to be "user-specified" accelerators.
2. No accelerator may clash with a previously defined accelerator, including any legal (alphanumeric) user-specified accelerator anywhere in the collection
3. Prefer alphanumerics at the start of the string.
4. Otherwise, prefer alphanumerics at the start of a word.
5. Otherwise, choose any alphanumeric character not already taken. If no such character is available, give up & skip this string.

A typical use of these functions would be to automatically assign accelerators to a dynamically populated popup menu. For example, the core code was written to automatically set accelerators for the "Load View Profile" popup menu for Konqueror. We quickly realized that it would be useful to make this facility more generally available, so I abstracted it out into a set of templates.

TODO:

- Add sugar functions for more collections.
- Add more Deref classes so that we can access a wider variety of collections.

## Function Documentation

template<class Iter , class Iter_Deref >

void KAccelGen::generate | ( | Iter | begin,
|  | Iter | end,
|  | QStringList & | target
| ) |  |

Main, maximally flexible template function that assigns accelerators to the elements of a collection of QStrings.

Clients will seldom use this directly, as it's usually easier to use one of the wrapper functions that simply takes a collection (see below).

The Deref template parameter is a class containing a static dereferencing function, modeled after the comparison class C in Stroustrup 13.4.

Parameters

  begin | (you know)
  end | (you know)
  target | collection to store generated strings

Definition at line 167 of file kaccelgen.h.

void KAccelGen::generate | ( | const QStringList & | source,
|  | QStringList & | target
| ) |  |

inline

Convenience function; generates accelerators for all the items in a QStringList.

Parameters

  source | Strings for which to generate accelerators
  target | Output for accelerator-added strings

Definition at line 245 of file kaccelgen.h.

template<class Iter >

void KAccelGen::generateFromKeys | ( | Iter | begin,
|  | Iter | end,
|  | QStringList & | target
| ) |  |

inline

Another convenience function; looks up the key instead of dereferencing directly for the given iterator.

Parameters

  begin |
  end |
  target |

Definition at line 232 of file kaccelgen.h.

template<class Data >

void KAccelGen::generateFromKeys | ( | const QMap< QString, Data > & | source,
|  | QStringList & | target
| ) |  |

inline

Convenience function; generates an accelerator mapping from all the keys in a QMap<QString,T>

Parameters

  source | Map with input strings as KEYS.
  target | Output for accelerator-added strings

Definition at line 271 of file kaccelgen.h.

template<class Key >

void KAccelGen::generateFromValues | ( | const QMap< Key, QString > & | source,
|  | QStringList & | target
| ) |  |

inline

Convenience function; generates accelerators for all the values in a QMap<T,QString>.

Parameters

  source | Map with input strings as VALUES.
  target | Output for accelerator-added strings

Definition at line 258 of file kaccelgen.h.

bool KAccelGen::isLegalAccelerator | ( | const QString & | str,
|  | uint | index
| ) |  |

inline

Helper to determine if the given offset in the string could be a legal alphanumeric accelerator.

Parameters

  str | base string
  index | offset to check

Definition at line 114 of file kaccelgen.h.

template<class Iter , class Deref >

void KAccelGen::loadPredefined | ( | Iter | begin,
|  | Iter | end,
|  | QMap< QChar, bool > & | keys
| ) |  |

inline

Loads all legal predefined accelerators in the (implicitly specified) collection into the given QMap.

Parameters

  begin | start iterator
  end | (last+1) iterator
  keys | map to store output

Definition at line 130 of file kaccelgen.h.

KDE Home | KDE Accessibility Home | Description of Access Keys